class even implements Runnable {
  private long num_rects = 1000000000;
  private double width = 1.0/(double)num_rects;
  public double sum;
  private double mid, height;
  public void run() {
    for (int i = 0; i < num_rects; i += 2) {
      mid = (i + 0.5) * width;
      height = 4.0/(1.0 + mid*mid);
      sum += height;
    }
  }
}

class odd implements Runnable {
  private long num_rects = 1000000000;
  private double width = 1.0/(double)num_rects;
  public double sum;
  private double mid, height;
  public void run() {
    for (int i = 1; i < num_rects; i += 2) {
      mid = (i + 0.5) * width;
      height = 4.0/(1.0 + mid*mid);
      sum += height;
    }
  }
}

public class pi_threaded {

  private static long num_rects = 1000000000;
  private static double width = 1.0/(double)num_rects;

  public static void main(String[] args) {

    double sum = 0.0;
    double area = 0.0;

    even e = new even();
    odd o = new odd();

    Thread t1 = new Thread(e);
    Thread t2 = new Thread(o);

    t1.start();
    t2.start();

    try {
      t1.join();
      t2.join();
    } catch (Exception ex) {
      ex.printStackTrace();
    }

    sum = e.sum + o.sum;
    area = width * sum;
    System.out.println("Computed pi = " + area);

  }

}
